# charset = utf-8

from datetime import datetime
from neomodel import db
from block.models import Account, Transaction, Contract, Miner, Block

db.set_connection('bolt://neo4j:lyh0214@localhost:7687/')


def test(i):
    time1 = datetime(year=2022, month=1, day=i)
    hash1 = '0xdf4af22891e6831a621c8641b3bb01d880117a7e01aab04a8b262385220c1b06' + str(i)
    hash2 = '0x8c46fe20c6d8d56f02e126f5d13231577ee6d56b5ec6a108fd6f222291de3263' + str(i)
    hash3 = '0xed77bac6775469ab6ef272bc918f0c9f7c019659f67fc3727cd97ea4de99954b' + str(i)
    hash4 = '0x12f5421f4e68c47d27068089ffe2bd02af0a4c9d34438153b1f872482f289292' + str(i)
    hash5 = '0xaea2c08b5f2b66e8460e332e364a6d478d9e7f5acc04db3b9f4a047f6a08fc01' + str(i)
    hash6 = '0xabe02f108f350877493fa49fb3017788333970ea2e78962b7f2b79707cda7b77' + str(i)
    b1 = Block(hash=hash1)
    b2 = Block(hash=hash2)
    b3 = Block(hash=hash3)
    b4 = Block(hash=hash4)
    t1 = Transaction(hash=hash5, amount=10000.0 + i * 100)
    t2 = Transaction(hash=hash6, amount=20000.0 + i * 100)
    address1 = '0x65f716f794026d4ff4723141100f0e3c3080e97d' + str(i)
    address2 = '0x687b6e85b9b08a33991b6ceeeb1d12df278a9a5b' + str(i)
    address3 = '0x17a84ba96a7374de9586a770b4529f57c6b991d6' + str(i)
    address4 = '0x422bc251a0582aba25e2dd3b27e80435bc13d402' + str(i)
    address5 = '0x2daa35962a6d43eb54c48367b33d0b379c930e5e' + str(i)
    address6 = '0x829bd824b016326a401d083b33d092293333a830' + str(i)
    a1 = Account(address=address1)
    a2 = Account(address=address2)
    c1 = Contract(address=address3)
    c2 = Contract(address=address4)
    m1 = Miner(address=address5)
    m2 = Miner(address=address6)
    for n in [b1, b2, b3, b4, t1, t2, a1, a2, c1, c2, m1, m2]:
        n.save()
    r1 = b1.next_block.connect(b2, {"index": "123", "date": time1})
    r2 = b3.next_block.connect(b4, {"index": "124", "date": time1})
    r3 = m1.pack.connect(b1, {"index": "125", "date": time1})
    r4 = m1.pack.connect(b2, {"index": "126", "date": time1})
    r5 = m1.pack.connect(b3, {"index": "127", "date": time1})
    r6 = m2.pack.connect(b4, {"index": "128", "date": time1})
    r77 = t1.trade.connect(b1, {"index": "129", "date": time1})
    r7 = t2.trade.connect(b3, {"index": "130", "date": time1})
    r8 = a1.transfer_out.connect(t1, {"index": "131", "date": time1})
    r9 = a2.transfer_out.connect(t2, {"index": "132", "date": time1})
    r10 = t1.transfer_in.connect(a1, {"index": "133", "date": time1})
    r11 = t1.invoke.connect(c1, {"index": "134", "date": time1})
    r12 = t2.invoke.connect(c2, {"index": "135", "date": time1})
    for r in [r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12, r77]:
        r.save()


def test2():
    time1 = datetime(year=2022, month=1, day=5)
    for i in range(10):
        account = Account.nodes[i:i+1][0]
        transaction = Transaction.nodes[i:i+1][0]
        r = account.transfer_out.connect(transaction, {"index": "131", "date": time1})
        r.save()


if __name__ == '__main__':
    # for i in range(1, 20):
    #     test(i)
    test2()
