# charset = utf-8

from datetime import datetime
from neomodel import db
from domain.models import Label, RequestIp, DnsIp, DomainName

db.set_connection('bolt://neo4j:lyh0214@localhost:7687/')


def test(i):
    t1 = datetime(year=2022, month=1, day=i)
    l1 = Label(label_name="恶意域名" + str(i))
    l2 = Label(label_name="境外域名" + str(i))

    l1.save()
    l2.save()
    req1 = RequestIp(request_ip='127.0.0.1' + str(i), province='四川', isp='电信')
    req2 = RequestIp(request_ip='127.0.0.2' + str(i), province='四川', isp='电信')
    req1.save()
    req2.save()
    d1 = DnsIp(dns_ip='127.0.0.3' + str(i))
    d2 = DnsIp(dns_ip='127.0.0.4' + str(i))
    d1.save()
    d2.save()
    do1 = DomainName(domain_name='www.baidu.com' + str(i))
    do2 = DomainName(domain_name='google.cn' + str(i))
    do1.save()
    do2.save()
    r1 = req1.request_domain.connect(do1, {"index": "123", "date": t1})
    r2 = req2.request_domain.connect(do2, {"index": "124", "date": t1})
    r3 = d1.parse_domain.connect(do1, {"index": "125", "date": t1})
    r4 = d2.parse_domain.connect(do2, {"index": "126", "date": t1})
    r5 = do1.label.connect(l1, {"index": "127", "date": t1})
    r6 = do2.label.connect(l2, {"index": "128", "date": t1})
    r8 = do1.label.connect(l2, {"index": "127", "date": t1})
    r7 = req1.request_domain.connect(do2, {"index": "124", "date": t1})
    for r in [r1, r2, r3, r4, r5, r6, r7, r8]:
        r.save()


def test1(i):
    t1 = datetime(year=2022, month=1, day=i).timestamp()
    t2 = datetime(year=2022, month=1, day=i).timestamp()
    param = {"ips": ['127.0.0.1' + str(i), '127.0.0.2' + str(i)]}
    query = 'match (r:RequestIp)-[req:REQUEST]->(d:DomainName)-[lab:LABEL]->(l:Label), (dns:DnsIp)-[par:PARSE]->(d)' \
            'where r.request_ip in $ips return r, d, l, dns, req, lab, par'
    items = db.cypher_query(query, param)[0]
    print(query)
    print(type(items))
    for item in items:
        nodes = item[:4]
        node = nodes[0]
        relations = item[4:]
        r = relations[0]
        # print(node.labels)
        # print(node)
        # node_type = list(getattr(node, "labels"))[0]
        # print(type(node_type))
        # print(r)
        # print(r.id)
        print((r.type))
        print(r.nodes[0].id)


def test2(i):
    t1 = datetime(year=2022, month=1, day=i)
    req1 = RequestIp(request_ip='127.0.0.10' + str(i), province='北京', isp='联通')
    req1.save()
    d1 = DnsIp(dns_ip='127.0.0.11' + str(i))
    d1.save()
    do1 = DomainName(domain_name='tencent.com' + str(i))
    do1.save()
    l1 = Label.nodes.filter(label_name='恶意域名' + str(i)).first()
    r1 = req1.request_domain.connect(do1, {"index": "221", "date": t1})
    r2 = d1.parse_domain.connect(do1, {"index": "299", "date": t1})
    r3 = do1.label.connect(l1, {"index": "199", "date": t1})
    r1.save()
    r2.save()
    r3.save()


def test3(i):
    t1 = datetime(year=2022, month=1, day=i)
    req1 = RequestIp(request_ip=('127.0.0.12' + str(i)), province='北京', isp='联通')
    d1 = DnsIp.nodes.filter(dns_ip=('127.0.0.11' + str(i))).first()
    req1.save()
    do1 = DomainName.nodes.filter(domain_name='tencent.com' + str(i)).first()
    r1 = req1.request_domain.connect(do1, {"index": "222", "date": t1})
    r2 = d1.parse_domain.connect(do1, {"index": "999", "date": t1})
    r1.save()
    r2.save()


def test4():
    param = {"ips": ['127.0.0.1', '127.0.0.2', '127.0.0.10', '127.0.0.12']}
    query = 'match (r:RequestIp)-[req:REQUEST]->(d:DomainName)-[lab:LABEL]->(l:Label) where r.request_ip in $ips ' \
            'return l.label_name, count(distinct lab), count(req) order by count(distinct lab) desc'
    items = db.cypher_query(query, param)[0]
    for item in items:
        a, b, c = item
        print("a=%s, b=%s, c=%s" % (a, b, c))


if __name__ == '__main__':
    # for i in range(1, 20):
    #     test(i)
    #     test2(i)
    #     test3(i)
    # test4()
    test(22)
