import random

from neomodel import db
from datetime import datetime
from route.models import RouteIp, FirstIp, EndIp

db.set_connection('bolt://neo4j:lyh0214@localhost:7687')


def test(i):
    t1 = datetime(year=2022, month=1, day=1)
    ip1 = '127.0.0.' + str(i)
    ip2 = '0.0.0.' + str(i)
    ip3 = '255.255.255.' + str(i)
    n1 = FirstIp(ip=ip1, country='中国', province='四川', city='成都', isp='电信', start_ip=ip1, root_ip=ip3)
    n2 = RouteIp(ip=ip2, country='中国', province='四川', city='成都', isp='电信', start_ip=ip1, root_ip=ip3)
    n3 = EndIp(ip=ip3, country='中国', province='四川', city='成都', isp='电信', start_ip=ip1, root_ip=ip3)
    n1.save()
    n2.save()
    n3.save()
    r1 = n1.next_ip.connect(n2, {"index": "123", 'date': t1})
    r2 = n1.next_ip.connect(n2, {"index": "124", 'date': t1})
    r3 = n2.next_ip.connect(n3, {"index": "125", 'date': t1})
    r4 = n2.next_ip.connect(n3, {"index": "126", 'date': t1})
    r1.save()
    r2.save()
    r3.save()
    r4.save()


def test1(i):
    province = ['四川', '北京', '上海', '山东']
    city = {
        '四川': '成都',
        '北京': '海淀',
        '上海': '浦东',
        '山东': '青岛',
    }
    isp = ['电信', '联通', '移动']
    t1 = datetime(year=2022, month=1, day=i)
    ip1 = '127.1.1.' + str(i)
    ip3 = '192.192.192.' + str(i)
    province1 = province[random.randint(0,3)]
    city1 = city[province1]
    isp1 = isp[random.randint(0, 2)]
    province3 = province[random.randint(0, 3)]
    city3 = city[province3]
    isp3 = isp[random.randint(0, 2)]
    n1 = FirstIp(ip=ip1, country='中国', province=province1, city=city1, isp=isp1, start_ip=ip1, root_ip=ip3)
    n3 = EndIp(ip=ip3, country='中国', province=province3, city=city3, isp=isp3, start_ip=ip1, root_ip=ip3)
    n1.save()
    n3.save()

    pre = n1
    for i in range(random.randint(3, 10)):
        ip2 = str(random.randint(0, 255)) + '.' + str(random.randint(0, 255)) + '.10.' + str(i)
        province2 = province[random.randint(0, 3)]
        city2 = city[province2]
        isp2 = isp[random.randint(0, 2)]
        n2 = RouteIp(ip=ip2, country='中国', province=province2, city=city2, isp=isp2, start_ip=ip1, root_ip=ip3)
        n2.save()
        r = pre.next_ip.connect(n2, {"index": "123"+str(ip2), 'date': t1})
        r.save()
        pre = n2

    r = pre.next_ip.connect(n3, {"index": "123" + str(ip3), 'date': t1})
    r.save()


if __name__ == "__main__":
    for i in range(1, 20):
        test(i)
